network/api/urls.py
"""SatNOGS Network django rest framework API url routings"""
from django.urls import path
from rest_framework import routers

from network.api import views

DEFAULT_ROUTER = routers.DefaultRouter()

DEFAULT_ROUTER.register(r'jobs', views.JobView, basename='jobs')
DEFAULT_ROUTER.register(r'observations', views.ObservationView, basename='observations')
DEFAULT_ROUTER.register(r'stations', views.StationView, basename='stations')

SIMPLE_ROUTER = routers.SimpleRouter()

SIMPLE_ROUTER.register(r'configuration', views.StationConfigurationView, basename='configuration')

API_URLPATTERNS = DEFAULT_ROUTER.urls + SIMPLE_ROUTER.urls + [
    path('transmitters/', views.transmitters_view),
    path('transmitters/<str:transmitter_uuid>', views.transmitter_detail_view),
    path('station/register', views.station_register_view),
    path('configuration/applied', views.StationConfigurationAppliedView.as_view())
]

network/base/urls.py
"""Django base URL routings for SatNOGS Network"""
from django.urls import path, re_path
from django.views.generic import TemplateView

from network.base.views import generic, observation, scheduling, station

BASE_URLPATTERNS = (
    [
        # Generic
        path('', generic.index, name='home'),
        path('about/', TemplateView.as_view(template_name='base/about.html'), name='about'),
        path('robots.txt', generic.robots, name='robots'),
        path('settings_site/', generic.settings_site, name='settings_site'),

        # Observations
        path('observations/', observation.ObservationListView.as_view(), name='observations_list'),
        re_path(
            r'^observations/(?P<observation_id>[0-9]+)/$',
            observation.observation_view,
            name='observation_view'
        ),
        re_path(
            r'^observations/(?P<observation_id>[0-9]+)/delete/$',
            observation.observation_delete,
            name='observation_delete'
        ),
        path(
            'vet-observations/',
            observation.VetObservationsView.as_view(),
            name='vet_observations'
        ),
        path(
            'vet-observations-chunks/',
            observation.VetObservationsChunkListView.as_view(),
            name='vet_observations_chunks'
        ),
        re_path(
            r'^waterfall_vet/(?P<observation_id>[0-9]+)/$',
            observation.waterfall_vet,
            name='waterfall_vet'
        ),
        path('satellites/<str:sat_id>/', observation.satellite_view, name='satellite_view'),
        # Stations
        path('stations_all/', station.station_all_view, name='stations_all'),
        path('stations/', station.StationListView.as_view(), name='stations_list'),
        re_path(r'^stations/(?P<station_id>[0-9]+)/$', station.station_view, name='station_view'),
        re_path(
            r'^stations/(?P<station_id>[0-9]+)/delete/$',
            station.station_delete,
            name='station_delete'
        ),
        re_path(
            r'^stations/(?P<station_id>[0-9]+)/delete_future_observations/$',
            station.station_delete_future_observations,
            name='station_delete_future_observations'
        ),
        re_path(
            'stations/register/step(?P<step>1)/$',
            station.station_register,
            name='station_register'
        ),
        re_path(
            'stations/register/step(?P<step>2)/$',
            station.station_register,
            name='station_register'
        ),
        re_path(
            'stations/register/step(?P<step>2)/(?P<station_id>[0-9]+)/$',
            station.station_register,
            name='station_register'
        ),
        path('stations/edit/', station.station_edit, name='station_edit'),
        re_path(
            r'^stations/edit/(?P<station_id>[0-9]+)/$', station.station_edit, name='station_edit'
        ),

        # Scheduling
        path('observations/new/', scheduling.observation_new, name='observation_new'),
        path('prediction_windows/', scheduling.prediction_windows, name='prediction_windows'),
        re_path(
            r'^pass_predictions/(?P<station_id>[\w.@+-]+)/$',
            scheduling.pass_predictions,
            name='pass_predictions'
        ),
        path('scheduling_stations/', scheduling.scheduling_stations, name='scheduling_stations'),
        path('transmitters/', scheduling.transmitters_view, name='transmitters_view'),
    ],
    'base'
)

network/urls.py
"""Base Django URL mapping for SatNOGS Network"""
from allauth import urls as allauth_urls
from django.conf import settings
from django.contrib import admin
from django.urls import include, path, re_path
from django.views.static import serve

from network.api.urls import API_URLPATTERNS
from network.base.urls import BASE_URLPATTERNS
from network.users.urls import USERS_URLPATTERNS

urlpatterns = [
    # Base urls
    path('', include(BASE_URLPATTERNS)),
    path('admin/', admin.site.urls),
    path('users/', include(USERS_URLPATTERNS)),
    path('api/', include(API_URLPATTERNS))
]

# Auth0
if settings.AUTH0:
    urlpatterns += [path('', include('auth0login.urls'))]
else:
    urlpatterns += [path('accounts/', include(allauth_urls))]

if settings.DEBUG:
    import debug_toolbar

    urlpatterns = [path('__debug__/', include(debug_toolbar.urls))] + urlpatterns

    urlpatterns += [
        re_path(r'^media/(?P<path>.*)$', serve, {'document_root': settings.MEDIA_ROOT}),
    ]

network/users/urls.py
"""Django users URL routings for SatNOGS Network"""
from django.urls import path, re_path

from network.users import views

USERS_URLPATTERNS = (
    [
        path('redirect/', views.UserRedirectView.as_view(), name='redirect_user'),
        path('update/', views.UserUpdateView.as_view(), name='update_user'),
        path('update/token/', views.update_user_token, name='update_user_token'),
        re_path(r'^(?P<username>[\w.@+-]+)/$', views.view_user, name='view_user'),
    ], 'users'
)

network/base/models.py
"""Django database base model for SatNOGS Network"""
import codecs
import re
from datetime import timedelta
from operator import truth

from django.conf import settings
from django.core.cache import cache
from django.core.exceptions import ValidationError
from django.core.files.storage import DefaultStorage
from django.core.validators import MaxLengthValidator, MaxValueValidator, MinLengthValidator, \
    MinValueValidator
from django.db import models
from django.db.models import Count, Q
from django.dispatch import receiver
from django.urls import reverse
from django.utils.html import format_html
from django.utils.timezone import now
from shortuuidfield import ShortUUIDField
from storages.backends.s3boto3 import S3Boto3Storage

from network.base.db_api import DBConnectionError, get_artifact_metadata_by_observation_id
from network.base.managers import ObservationManager
from network.base.utils import bands_from_range
from network.users.models import User

OBSERVATION_STATUSES = (
    ('unknown', 'Unknown'),
    ('good', 'Good'),
    ('bad', 'Bad'),
    ('failed', 'Failed'),
)
STATION_STATUSES = (
    (2, 'Online'),
    (1, 'Testing'),
    (0, 'Offline'),
)
STATION_VIOLATOR_SCHEDULING_CHOICES = (
    (0, 'No one'),
    (1, 'Only Operators'),
    (2, 'Everyone'),
)
SATELLITE_STATUS = ['alive', 'dead', 'future', 're-entered']
TRANSMITTER_STATUS = ['active', 'inactive', 'invalid']
TRANSMITTER_TYPE = ['Transmitter', 'Transceiver', 'Transponder']


def _decode_pretty_hex(binary_data):
    """Return the binary data as hex dump of the following form: `DE AD C0 DE`"""

    data = codecs.encode(binary_data, 'hex').decode('ascii').upper()
    return ' '.join(data[i:i + 2] for i in range(0, len(data), 2))


def _name_obs_files(instance, filename):
    """Return a filepath formatted by Observation ID"""
    return 'data_obs/{0}/{1}'.format(instance.id, filename)


def _name_obs_demoddata(instance, filename):
    """Return a filepath for DemodData formatted by Observation ID"""
    # On change of the string bellow, change it also at api/views.py
    return 'data_obs/{0}/{1}'.format(instance.observation.id, filename)


def _name_observation_data(instance, filename):
    """Return a filepath formatted by Observation ID"""
    return 'data_obs/{0}/{1}/{2}/{3}/{4}/{5}'.format(
        instance.start.year, instance.start.month, instance.start.day, instance.start.hour,
        instance.id, filename
    )


def _name_observation_demoddata(instance, filename):
    """Return a filepath for DemodData formatted by Observation ID"""
    # On change of the string bellow, change it also at api/views.py
    return 'data_obs/{0}/{1}/{2}/{3}/{4}/{5}'.format(
        instance.observation.start.year, instance.observation.start.month,
        instance.observation.start.day, instance.observation.start.hour, instance.observation.id,
        filename
    )


def _select_audio_storage():
    return S3Boto3Storage() if settings.USE_S3_STORAGE_FOR_AUDIO else DefaultStorage()


def _select_waterfall_storage():
    return S3Boto3Storage() if settings.USE_S3_STORAGE_FOR_WATERFALL else DefaultStorage()


def _select_data_storage():
    return S3Boto3Storage() if settings.USE_S3_STORAGE_FOR_DATA else DefaultStorage()


def validate_image(fieldfile_obj):
    """Validates image size"""
    filesize = fieldfile_obj.file.size
    megabyte_limit = 2.0
    if filesize > megabyte_limit * 1024 * 1024:
        raise ValidationError("Max file size is %sMB" % str(megabyte_limit))


def get_default_station_configuration_schema():
    """Generate default value for schema field of StationConfigurationSchema model"""
    return {}


def get_default_station_configuration():
    """Generate default value for schema field of StationConfiguration model"""
    return {}


class StationType(models.Model):
    """Model for SatNOGS station types"""
    name = models.CharField(max_length=10, unique=True)

    def __str__(self):
        return self.name


class StationConfigurationSchema(models.Model):
    """Model for SatNOGS station configuration schemas"""
    name = models.CharField(max_length=100)
    station_type = models.ForeignKey('StationType', on_delete=models.CASCADE)
    schema = models.JSONField(default=get_default_station_configuration_schema)

    def __str__(self):
        return self.station_type.name + ' - ' + self.name

    class Meta:
        unique_together = ['name', 'station_type']


class StationConfiguration(models.Model):
    """Model for SatNOGS station configuration schemas"""
    name = models.CharField(max_length=100)
    station = models.ForeignKey('Station', on_delete=models.CASCADE)
    schema = models.ForeignKey('StationConfigurationSchema', on_delete=models.CASCADE)
    configuration = models.JSONField(default=get_default_station_configuration)
    active = models.BooleanField(default=True)
    applied = models.DateTimeField(blank=True, null=True)
    created = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.name


class ActiveStationConfigurationManager(models.Manager):  # pylint: disable=R0903
    """Django Manager for ActiveStationConfiguration objects"""

    def get_queryset(self):
        """Returns query of StationConfigurations

        :returns: the active configurations for stations
        """
        return super().get_queryset().filter(active=True)


class ActiveStationConfiguration(StationConfiguration):
    """Proxy model for StationConfiguration that contains only active ones"""
    objects = ActiveStationConfigurationManager()

    class Meta:
        proxy = True


class Station(models.Model):
    """Model for SatNOGS ground stations."""
    owner = models.ForeignKey(
        User, related_name="ground_stations", on_delete=models.SET_NULL, null=True, blank=True
    )
    name = models.CharField(max_length=45)
    image = models.ImageField(upload_to='ground_stations', blank=True, validators=[validate_image])
    alt = models.IntegerField(
        null=True,
        blank=True,
        validators=[MinValueValidator(-500)],
        help_text='In meters above sea level'
    )
    lat = models.FloatField(
        null=True,
        blank=True,
        validators=[MaxValueValidator(90), MinValueValidator(-90)],
        help_text='eg. 38.01697'
    )
    lng = models.FloatField(
        null=True,
        blank=True,
        validators=[MaxValueValidator(180), MinValueValidator(-180)],
        help_text='eg. 23.7314'
    )
    # https://en.wikipedia.org/wiki/Maidenhead_Locator_System
    qthlocator = models.CharField(max_length=8, blank=True)
    featured_date = models.DateField(null=True, blank=True)
    created = models.DateTimeField(auto_now_add=True)
    testing = models.BooleanField(default=True)
    last_seen = models.DateTimeField(null=True, blank=True)
    status = models.IntegerField(choices=STATION_STATUSES, default=0)
    violator_scheduling = models.IntegerField(
        choices=STATION_VIOLATOR_SCHEDULING_CHOICES, default=0
    )
    horizon = models.PositiveIntegerField(help_text='In degrees above 0', default=10)
    description = models.TextField(max_length=500, blank=True, help_text='Max 500 characters')
    client_version = models.CharField(max_length=45, blank=True)
    target_utilization = models.IntegerField(
        validators=[MaxValueValidator(100), MinValueValidator(0)],
        help_text='Target utilization factor for '
        'your station',
        null=True,
        blank=True
    )
    client_id = models.CharField(max_length=128, blank=True)
    active_configuration_changed = models.DateTimeField(blank=True, null=True)

    class Meta:
        ordering = ['-status', 'id']
        indexes = [models.Index(fields=['-status', 'id'])]

    @property
    def active_configuration(self):
        """Returns the currently used configuration of the station"""
        try:
            conf = ActiveStationConfiguration.objects.get(station=self)
        except ActiveStationConfiguration.DoesNotExist:
            conf = None
        return conf

    def get_image(self):
        """Return the image of the station or the default image if there is a defined one"""
        if self.image and hasattr(self.image, 'url'):
            return self.image.url
        return settings.STATION_DEFAULT_IMAGE

    @property
    def is_online(self):
        """Return true if station is online"""
        try:
            heartbeat = self.last_seen + timedelta(minutes=int(settings.STATION_HEARTBEAT_TIME))
            return heartbeat > now()
        except TypeError:
            return False

    @property
    def is_offline(self):
        """Return true if station is offline"""
        return not self.is_online

    @property
    def has_location(self):
        """Return true if station location is defined"""
        if self.alt is None or self.lat is None or self.lng is None:
            return False
        return True

    @property
    def is_testing(self):
        """Return true if station is online and in testing mode"""
        if self.is_online:
            if self.status == 1:
                return True
        return False

    def state(self):
        """Return the station status in html format"""
        if not self.status:
            return format_html('<span style="color:red;">Offline</span>')
        if self.status == 1:
            return format_html('<span style="color:orange;">Testing</span>')
        return format_html('<span style="color:green">Online</span>')

    @property
    def success_rate(self):
        """Return the success rate of the station - successful observation over failed ones"""
        rate = cache.get('station-{0}-rate'.format(self.id))
        if not rate:
            observations = self.observations.exclude(experimental=True
                                                     ).exclude(status__range=(0, 99))
            stats = observations.aggregate(
                bad=Count('pk', filter=Q(status__range=(-100, -1))),

network/users/forms.py
"""Django users forms for SatNOGS Network"""
from django import forms

from network.users.models import User


class UserForm(forms.ModelForm):
    """Model Form class for User objects"""

    class Meta:
        model = User
        fields = ("first_name", "last_name")

network/base/views/generic.py
"""Django base views for SatNOGS Network"""
from django.conf import settings
from django.contrib import messages
from django.http import HttpResponse
from django.shortcuts import redirect, render
from django.urls import reverse

from network.base.decorators import staff_required
from network.base.tasks import fetch_satellites, update_future_observations_with_new_tle_sets, \
    update_future_observations_with_new_transmitter_details


def index(request):
    """View to render index page."""
    return render(
        request, 'base/home.html', {
            'mapbox_id': settings.MAPBOX_MAP_ID,
            'mapbox_token': settings.MAPBOX_TOKEN
        }
    )


def robots(request):
    """Returns response for robots.txt requests"""
    data = render(request, 'robots.txt', {'environment': settings.ENVIRONMENT})
    response = HttpResponse(data, content_type='text/plain; charset=utf-8')
    return response


@staff_required
def settings_site(request):
    """View to render settings page."""
    if request.method == 'POST':
        fetch_satellites.delay()
        update_future_observations_with_new_tle_sets.delay()
        update_future_observations_with_new_transmitter_details.delay()
        messages.success(request, 'Data fetching task was triggered successfully!')
        return redirect(reverse('users:view_user', kwargs={"username": request.user.username}))
    return render(request, 'base/settings_site.html')

network/templates/base/about.html
{% extends "base.html" %}

{% block title %} - About{% endblock %}

{% block content %}
  <div class="row">
    <div class="col-md-12">
      <h2>About</h2>
      <h3>SatNOGS Network</h3>
      SatNOGS Network is a global management interface to facilitate multiple ground station
      operations remotely. An observer is able to take advantage of the full network of
      SatNOGS ground stations around the world.
      It's part of the <a href="https://satnogs.org/" target="_blank">SatNOGS project</a>.
      <h3>Observations</h3>
      The network is open to anyone. Any observer is able to utilize all available Ground Stations
      and communicate with Satellites. All observations results are public
      and all data are distributed freely under the
      <a href="https://creativecommons.org/licenses/by-sa/4.0/" target="_blank">Creative Commons Atribution-Share Alike</a> license.
      <h3>Ground Stations</h3>
      Whether you own satellite ground station equipment or you want
      to build one you can head to
      <a href="https://satnogs.org" target="_blank">SatNOGS Project site</a>
      to get up to date documentation and info on <a href="https://wiki.satnogs.org" target="_blank">how to build a SatNOGS ground station</a>.
      <h3>Coding</h3>
      Fluent in Python and/or JS? We need you to help with satnogs-network web application. Take a look to our
      <a href="https://gitlab.com/librespacefoundation/satnogs/satnogs-network/" target="_blank">source code</a> or visit
      our <a href="https://gitlab.com/librespacefoundation/satnogs/satnogs-network/issues" target="_blank">issues tracker</a>
      to start filing bugs, feature requests or code fixes for existing ones.
      Detailed contribution and development documentation is also available at
      <a href="https://docs.satnogs.org/projects/satnogs-network/en/stable/" target="_blank">docs.satnogs.org</a>.
    </div>
  </div>
{% endblock content %}

network/templates/base/observation_view.html
{% extends "base.html" %}
{% load static %}

{% block title %} - Observation {{ observation.id }}{% endblock %}

{% block css %}
  <link rel="stylesheet" href="{% static 'lib/jquery.json-viewer/json-viewer/jquery.json-viewer.css' %}">
{% endblock css %}

{% block content %}
    {% include "includes/observation_detail.html" with observation=observation from_vetting=False %}
{% endblock content %}

{% block javascript %}
  <script src="{% static 'lib/wavesurfer.js/dist/wavesurfer.min.js' %}"></script>
  <script src="{% static 'lib/wavesurfer.js/dist/plugin/wavesurfer.spectrogram.min.js' %}"></script>
  <script src="{% static 'lib/moment/min/moment.min.js' %}"></script>
  <script src="{% static 'lib/jquery.json-viewer/json-viewer/jquery.json-viewer.js' %}"></script>
  <script src="{% static 'lib/satellite.js/dist/satellite.min.js' %}"></script>
  <script src="{% static 'lib/kaitai-struct/KaitaiStream.js' %}"></script>
  <script src="{% static 'js/utc.js' %}"></script>
  <script src="{% static 'js/polar_svg.js' %}"></script>
  <script src="{% static 'js/observation_view.js' %}"></script>
  <script src="{% static 'js/satellite.js' %}"></script>
  <script src="{% static 'js/ax25monitor.js' %}"></script>
{% endblock javascript %}

network/templates/base/settings_site.html
{% extends "base.html" %}
{% load static %}

{% block title %} - Site Settings{% endblock %}

{% block content %}
  <div class="row">
    <div class="col-md-12">
      <h1>Settings</h1>

      <h3>Fetch Data</h3>

      <p>You can update from DB all Satellites data and update all future observations with newest TLE sets and updated Transmitters.</p>

      <form id="fetchform" method="post" class="form-horizontal" role="form" action="{% url 'base:settings_site' %}">{% csrf_token %}
        <input type="hidden" name="fetch" value="true">
        <button class="btn btn-primary" type="submit">Fetch</button>
      </form>

    </div>
  </div>
{% endblock content %}

{% block javascript %}
  <script src="{% static 'js/settings_site.js' %}"></script>
{% endblock javascript %}

network/templates/base/stations.html
{% extends "base.html" %}
{% load tags %}
{% load static %}

{% block title %} - Ground Stations{% endblock %}

{% block css %}
  <link rel="stylesheet" href="{% static 'lib/maplibre-gl/dist/maplibre-gl.css' %}">
{% endblock css %}

{% block content %}
  <div class="row">
    <div class="col col-md-5">
      <h2>
        Ground Stations
      </h2>
    </div>

    <div class="col d-none d-lg-flex justify-content-end align-items-center">
      {% if is_paginated %}
          {% load paginator %}{% paginator request 3%}
      {% endif %}
      <span class="stations-actions">
        <a class="btn btn-outline-dark" role="button" data-toggle="collapse"
           href="#collapseFilters" aria-expanded="false" aria-controls="collapseFilters">
          <span class="bi bi-funnel-fill" aria-hidden="true"></span>
        </a>
        <a href='#map' class="btn btn-outline-dark" role="button" data-toggle="modal" data-target="#MapModal">
          <span class="bi bi-geo-alt-fill" aria-hidden="true"></span> Map
        </a>
      </span>
    </div>

    <div class="col d-flex d-lg-none justify-content-end align-items-center">
      <span class="stations-actions">
        <a class="btn btn-outline-dark" role="button" data-toggle="collapse"
                href="#collapseFilters" aria-expanded="false" aria-controls="collapseFilters">
          <span class="bi bi-funnel-fill" aria-hidden="true"></span>
        </a>
        <a href='#map' class="btn btn-outline-dark" role="button" data-toggle="modal" data-target="#MapModal">
          <span class="bi bi-geo-alt-fill" aria-hidden="true"></span>
        </a>
      </span>
    </div>
  </div>

  <div class="collapse px-2 pt-2" id="collapseFilters" data-filtered="{{ is_filtered }}">
    <div class="filter-section card">
      <form id="station-filter" class="row" method="get" action="{% url 'base:stations_list' %}">
        {% for error in freq_filter_errors %}
          <div class="alert alert-danger" role="alert">{{error}}</div>
        {% endfor %}
        <div class="form-group status-filter col-md-4 col-lg-3">
          <label for="status-selector">Status</label>
          <div id="status-selector" class="btn-group-toggle" role="group" aria-label="Group of status filters" data-toggle="buttons">
            <label class="btn btn-good btn-sm {% if online is False %}active btn-inactive{% endif %}"
                   aria-expanded="true"
                   aria-controls="online"
                   data-toggle="tooltip"
                   data-placement="bottom"
                   title="Online">
              <input type="checkbox" name="online" value="0" {% if online is False %}checked{% endif %} autocomplete="off">
              <span class="bi bi-check" aria-hidden="true"></span>
            </label>
            <label class="btn btn-unknown btn-sm {% if testing is False %}active btn-inactive{% endif %}"
                   aria-expanded="true"
                   aria-controls="testing"
                   data-toggle="tooltip"
                   data-placement="bottom"
                   title="Testing">
              <input type="checkbox" name="testing" value="0" {% if testing is False %}checked{% endif %} autocomplete="off">
              <span class="bi bi-question-circle" aria-hidden="true"></span>
            </label>
            <label class="btn btn-bad btn-sm {% if offline is False %}active btn-inactive{% endif %}"
                   aria-expanded="true"
                   aria-controls="offline"
                   data-toggle="tooltip"
                   data-placement="bottom"
                   title="Offline">
              <input type="checkbox" name="offline" value="0" {% if offline is False %}checked{% endif %} autocomplete="off">
              <span class="bi bi-x" aria-hidden="true"></span>
            </label>
            <label class="btn btn-future btn-sm {% if future is False %}active btn-inactive{% endif %}"
                   aria-expanded="true"
                   aria-controls="future"
                   data-toggle="tooltip"
                   data-placement="bottom"
                   title="Future">
              <input type="checkbox" name="future" value="0" {% if future is False %}checked{% endif %} autocomplete="off">
              <span class="bi bi-clock" aria-hidden="true"></span>
            </label>
          </div>
        </div>
        <div id="frequency-filter-formgroup" class="form-group frequency-filter col-md-4 col-lg-3 {% if freq_filter_errors %}has_error{% endif %}">
            <label class="frequency-filter-label" for="frequency-filter">Frequency</label>
            <div class="freq-input-container">
              <input name="freq" id="frequency-filter" min="0" type="number" step="1" value="{{freq}}" class="frequency-filter-input form-control" autocomplete="off"/>
              <span id="freq-format"></span>
            </div>
        </div>
        <div class="form-group col-md-12 text-center">
          <button id="filter-button" type="submit" class="btn btn-primary">Update filters</button>
        </div>
      </form>
    </div>
  </div>

  <div class="row">
    <div class="col-md-12">
      <table class="table table-hover my-2">
        <thead class="bg-light">
          <th>ID</th>
          <th>Name</th>
          <th>Location</th>
          <th>Total</th>
          <th>Future</th>
          <th>Antennas</th>
          <th>Owner</th>
        </thead>
        <tbody>
          {% for station in stations %}
            <tr class="station-row clickable-row" data-href="{% url 'base:station_view' station_id=station.id %}">
              <td>
                <a href="{% url 'base:station_view' station_id=station.id %}">
                  <span class="station
                               {% if station.last_seen %}
                                 badge badge-{{ station.get_status_display|lower }}
                               {% else %}
                                 badge badge-future
                               {% endif %}"
                        data-toggle="tooltip"
                        data-placement="bottom"
                        title="{% if station.last_seen %}
                                 Seen {{ station.last_seen|timesince }} ago
                               {% else %}
                                 Never seen online
                               {% endif %}">
                    {{ station.id }}
                  </span>
                </a>
              </td>
              <td>
                {{ station.name }}
              </td>
                <td>
                  {% if station.has_location %}
                    {% if station.qthlocator %}
                      <span data-toggle="tooltip" data-placement="bottom"
                            title="{{ station.lat|floatformat:-3 }}°, {{ station.lng|floatformat:-3 }}°">
                      {{ station.qthlocator }}
                    {% else %}
                      {{ station.lat|floatformat:-1 }}°, {{ station.lng|floatformat:-1 }}°
                    {% endif %}
                    @{{ station.alt}}m
                  {% else %}
                    Location not defined
                  {% endif %}
                </td>
              <td>
                <a href="{% url 'base:observations_list' %}?station={{ station.id }}" class="badge badge-success badge-pill" data-placement="bottom">
                  {{ station.observations_stats.total }}
                </a>
              </td>
              <td>
                <a href="{% url 'base:observations_list' %}?future=1&good=0&bad=0&unknown=0&failed=0&station={{ station.id }}" class="badge badge-info badge-pill">
                  {{ station.observations_stats.future }}
                </a>
              </td>
              <td class="antennas">
                {% for antenna in station.antennas.all %}
                  <span class="antenna-pill" data-toggle="tooltip" data-placement="bottom"
                        title="{% for range in antenna.frequency_ranges.all %} {{ range.min_frequency|frq }} - {{ range.max_frequency|frq }}&#xA{% endfor %}">
                    {{ antenna.antenna_type }} ({{ antenna.bands}})
                  </span>
                {% endfor %}
              </td>
              <td>
                {% if station.owner %}
                <a href="{% url 'users:view_user' username=station.owner.username %}">
                  {{ station.owner.displayname }}
                </a>
                {% else %}
                 -
                {% endif %}
              </td>
            </tr>
          {% endfor %}
        </tbody>
      </table>
      {% if is_paginated %}{% load paginator %}{% paginator request 3 %}{% endif %}
      <div class="text-center mt-2">
        Query returned {{ stations|length }} station{{ stations|length|pluralize }}.
      </div>
    </div>
  </div>

  <!-- Modal -->
  <div class="modal fade map-modal" id="MapModal" tabindex="-1" role="dialog" aria-labelledby="MapModalTitle" aria-hidden="true">
    <div class="modal-dialog modal-xl" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h3 class="modal-title" id="MapModalTitle">Stations Map</h3>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <div id="map" data-mapboxid="{{ mapbox_id }}" data-mapboxtoken="{{ mapbox_token }}" data-stations="{% url 'base:stations_all' %}"></div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-outline-dark" data-dismiss="modal">Close</button>
        </div>
      </div>
    </div>
  </div>
{% endblock content %}


{% block javascript %}
  <script src="{% static 'lib/maplibre-gl/dist/maplibre-gl.js' %}"></script>
  <script src="{% static 'js/stations.js' %}"></script>
  <script src="{% static 'js/map.js' %}"></script>
{% endblock %}